/*** Aufgabe_11_3.cpp ***/
/*
1. Erklaeren Sie zunaechst anhand eines Beispiels, warum die obige 
Berechung die Grossbuchstaben das richtige Ergebnis liefert. 

2. Wie muss das n gewaehlt werden, damit das Ver- und Entschluesseln
von Grossbuchstaben mit derselben Berechnung funktioniert?  
Wie stattdessen fuer Ziffern?

3. Warum koennen mit n = 65 sowohl Buchstaben als auch Ziffern ver- und 
entschluesselt werden?
*/
#include <iostream>
#include <cctype>
using namespace std;

char caesarChiffre (char const c, unsigned int const n) {
    if ( isupper(c) ) {
        return 'A' + ( c - 'A' + n ) % 26;
    }
    // ****************************************
    // 4. Hier beliebig viele Zeilen ergaenzen
    // ****************************************
    return c;
}

int main () {
    unsigned int const n = 65;
    char klarText[] =    "CAESAR-VERSCHLUESSELUNG mit 39 ZEICHEN!";
    char verschlText[] = "IREFPUYHRFFRYGR GRKG zvg 81 MRVPURA!";

    cout << "Verschluesselte Text: ";

    // Text verschluesseln
    for( unsigned int i = 0; klarText[i] != '\0'; ++i ) {
        cout << caesarChiffre(klarText[i], n);
    }

    cout << endl << "Entschluesselte Text: ";

    // Text entschluesseln
    for( unsigned int i = 0; verschlText[i] != '\0'; ++i ) {
        cout << caesarChiffre(verschlText[i], n);
    }

    return 0;
}
/* Ausgabe:
Verschluesselte Text: PNRFNE-IREFPUYHRFFRYHAT mit 39 MRVPURA!
Entschluesselte Text: VERSCHLUESSELTE TEXT zvg 81 ZEICHEN!
*/
/*** Ende Aufgabe_11_3.cpp ***/
